startXp = GetUnitXPMax( "player" ) - GetUnitXP( "player" )
averageXpTable = {}
averageXpCount = 0
averageXpHourlyTable = {}
averageXpHourlyCount = 0
timeStart = GetGameTimeMilliseconds()
timeElapsed = 0
framesLocked = true

function OnLoad( self, tableName )
	self:SetAnchor(WgSV[tableName].Point, nil, nil, WgSV[tableName].offsetX, WgSV[tableName].offsetY)
end

function AverageXP( lastXp )
	averageXpTotal = 0
	averageXpHourlyTotal = 0
	timeElapsed = GetGameTimeMilliseconds() - timeStart
	
	if ( lastXp > 0 ) then
		table.insert( averageXpTable , lastXp )
		averageXpCount = averageXpCount + 1
		
		table.insert( averageXpHourlyTable , lastXp )
		averageXpHourlyCount = averageXpHourlyCount + 1
	end	
	
	if ( averageXpCount >= 5 ) then
		table.remove( averageXpTable, 1 )
		averageXpCount = averageXpCount - 1
	end
	
	for index, xpVals in ipairs( averageXpTable ) do
		averageXpTotal = averageXpTotal + xpVals
	end
	averageXp = {}
	if ( averageXpTotal > 0 ) then
		averageXp.total = averageXpTotal / averageXpCount
	else
		averageXp.total = 0
	end	
	
	if timeElapsed >= 300000 then		
		for vals in pairs( averageXpHourlyTable ) do
			averageXpHourlyTable [vals] = nil			
		end
		averageXpHourlyCount = 0
		timeStart = GetGameTimeMilliseconds()
		timeElapsed = GetGameTimeMilliseconds() - timeStart
	end
	
	if ( timeElapsed < 300000 ) then
		for index, xpVals in ipairs( averageXpHourlyTable ) do
			averageXpHourlyTotal = averageXpHourlyTotal + xpVals
		end
		
		calc = 3600000 / timeElapsed
		multiplyBy = math.floor( calc + 0.5 )
		if ( multiplyBy > 180 ) then
			mutiplyBy = 180
		end
		
		if ( averageXpHourlyTotal > 0 ) then
			hourlyAverage = averageXpHourlyTotal / averageXpHourlyCount
			averageXp.hourly = hourlyAverage * multiplyBy
		else
			averageXp.hourly = 0
		end
	end
	
	return averageXp
end

function UpdateXP( eventCode, unitTag, currentExp, maxExp, reason )
	if (unitTag ~= "player" ) then return end
	
	endXp = maxExp - currentExp
	lastXp = startXp - endXp
	xpPercent = currentExp / maxExp * 100
	
	avgXp = AverageXP(lastXp)
	
	XPStats:SetText(string.format("XP %d%%        Last 5 Average XP: %d        Last XP Gained: %d", xpPercent, avgXp.total, lastXp))
	XPBar:SetValue( xpPercent )	
	
	XPHourlyStats:SetText(string.format("Hourly XP: %d", avgXp.hourly))
	startXp = maxExp - currentExp
	
end

function OnMoveStop( self, tableName )
	WgSV[tableName].offsetX = self:GetLeft()
	WgSV[tableName].offsetY = self:GetTop()
	WgSV[tableName].Point = TOPLEFT
end

function AddOnLoaded(eventCode, addOnName)
	if (addOnName == "WarGenesisSimpleXP") then
		defaults = {
		["XP"] = {
			["Point"] = BOTTOM,
			["offsetY"] = -90,
			["offsetX"] = 0 },
		["Hour"] = {
			["Point"] = BOTTOM,
			["offsetY"] = -115,
			["offsetX"] = 0 }
		}
		
		WgSV = ZO_SavedVars:New( "WGSX" , 2 , nil , defaults , nil )
		
		OnLoad( XP, "XP" )
		OnLoad( XPHourly, "Hour" )
		UpdateXP(0, "player", GetUnitXP( "player" ), GetUnitXPMax( "player" ), 1)
		
		LAM = LibStub("LibAddonMenu-1.0")
		panelID = LAM:CreateControlPanel( "WarGenesisSimpleXP_ID", "Simple XP")
		
		LAM:AddHeader(panelID, "WarGenesisAddOn_Name", "version 1.2")
		
		LAM:AddCheckbox(panelID, "LockFrames", "Lock Frames", "Unlock or Lock the frames to move items around.", function() return framesLocked end, function() framesLocked = not framesLocked ZO_OptionsWindow:SetHidden(true) GetLocked() end, false, nil )
	end
end

function SetLocked()
	framesLocked = not framesLocked
end

function GetLocked()
	if ( framesLocked ) then
		XPLockFrames:SetHidden ( true )
	else
		XPLockFrames:SetHidden ( false )	
		XP:SetHidden ( false )
		XPHourly:SetHidden ( false )
	end
end

function OnReticleHidden ( eventCode , hidden )
	if ( framesLocked and hidden ) then
		XP:SetHidden ( true )
		XPHourly:SetHidden ( true )		
	elseif ( not framesLocked and not hidden ) then
		XP:SetHidden ( false )
		XPHourly:SetHidden ( false )
		SetLocked()
	else		
		XP:SetHidden ( false )
		XPHourly:SetHidden ( false )
	end
	
end
EVENT_MANAGER:RegisterForEvent( "WarGenesisSimpleXP" , EVENT_ADD_ON_LOADED , AddOnLoaded )
EVENT_MANAGER:RegisterForEvent( "WarGenesisSimpleXP" , EVENT_EXPERIENCE_UPDATE, UpdateXP)
EVENT_MANAGER:RegisterForEvent( "WarGenesisSimpleXP" , EVENT_RETICLE_HIDDEN_UPDATE , OnReticleHidden)